#pragma once

#ifndef _MSOAV_H
#define _MSOAV_H

typedef struct _msoavinfo
{
	int cbsize;                         // Integer value that specifies the size of the caller's MSOAVINFO structure.
	struct {
		ULONG fPath:1;              // If set, use pwzFullPath; if cleared, use lpstg.
		ULONG fReadOnlyRequest:1;   // File is opened read-only.
		ULONG fInstalled:1;         // The file at pwzFullPath is an installed file.
		ULONG fHttpDownload:1;      // The file at pwzFullPath is a temp file downloaded from http/ftp.
		ULONG fVBAStg:1;            // If set, the IStorage* at lpstgVBA is the decrypted OpenXML macro storage.
		};
	HWND hwnd;                          // Parent window of the Office application, if available.
	union {
		WCHAR *pwzFullPath;         // Full path to the file about to be opened
		LPSTORAGE lpstg;            // OLE Storage of the document about to be opened
		} u;
	WCHAR *pwzHostName;                 // Host application's name
	WCHAR *pwzOrigURL;                  // URL of the origin of a downloaded file.
	LPSTORAGE lpstgVBA;                 // (Decrypted) OLE Storage of the macros (this is specific for Office 2007 and later)
} MSOAVINFO;

 // {56FFCC30-D398-11d0-B2AE-00A0C908FA49}
DEFINE_GUID(IID_IOfficeAntiVirus,
0x56ffcc30, 0xd398, 0x11d0, 0xb2, 0xae, 0x0, 0xa0, 0xc9, 0x8, 0xfa, 0x49);

 // {56FFCC30-D398-11d0-B2AE-00A0C908FA49}
DEFINE_GUID(CATID_MSOfficeAntiVirus,
0x56ffcc30, 0xd398, 0x11d0, 0xb2, 0xae, 0x0, 0xa0, 0xc9, 0x8, 0xfa, 0x49);

#undef  INTERFACE
#define INTERFACE  IOfficeAntiVirus
DECLARE_INTERFACE_(IOfficeAntiVirus, IUnknown)
{
    BEGIN_INTERFACE

    // *** IUnknown methods ***
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    // *** IOfficeAntiVirus methods ***
    STDMETHOD_(HRESULT, Scan)(THIS_ MSOAVINFO *pmsoavinfo) PURE;
};

#define MsoFVerifyDecryptedVBAStorage(pmsoavinfo) \
	(((pmsoavinfo) != NULL) && \
	(reinterpret_cast<size_t>(pmsoavinfo) + (pmsoavinfo)->cbsize >= reinterpret_cast<size_t>(&((pmsoavinfo)->lpstgVBA)) + sizeof(LPSTORAGE)) && \
	((pmsoavinfo)->fVBAStg) && \
	((pmsoavinfo)->lpstgVBA != NULL))

#endif // _MSOAV_H
